// @see http://www.nicovideo.jp/watch/sm23871006
// put Beam_lv1_Particle.mqo in same folder/directory

#define ParticleNum	510 // depend on Beam_lv1_Particle.mqo
#define PI                    3.14159265
//#define PI   3.1415926535897932384626433832795
#define PI_2 (PI*0.5)
#define PI2  (PI*2.0)

//#define particleSystemLength 32.0
#define particleSystemLength 4.0
#define particleSize          1.0

//#define MAX        2147483647
//#define MAX             65536
//#define MAX           32768
#define MAX             512 // depend on Beam_lv1_Particle.mqo

uniform float time;
varying vec2  texOffset;
varying float	alpha;

#extension GL_EXT_gpu_shader4 : enable

/**
 * @param i
 * @return [0.0, 1.0)
 */
vec4 getRandom(/*float index*/int i) {
	vec4 random;
//	int i = int(index);
	random.x = float(((i<<2)+1)*(i+1) % MAX);//non linear congruential method
	int x = int(random.x);
	random.y = float(((x<<2)+1)*(x+1) % MAX);//non linear congruential method
	int y = int(random.y);
	random.z = float(((y<<2)+1)*(y+1) % MAX);//non linear congruential method
	int z = int(random.z);
	random.w = float(((z<<2)+1)*(z+1) % MAX);//non linear congruential method

//	random.x     = float(int(random.x)%MAX);
//	random.y     = float(int(random.y)%MAX);
//	random.z     = float(int(random.z)%MAX);
//	random.w     = float(int(random.w)%MAX);
	random    /= float(MAX);
	return random;
}

float inv_pow(float f, float p){
	return 1.0-(pow(1.0-f, p));
}

void AllFunc()
{
	int index = int((gl_Vertex.x + gl_Vertex.y)*float(ParticleNum-1));

	vec4 random = getRandom(index+123);
	float w   = 0.1*particleSize*(2.0+random.x*5.0);

	vec3 add = vec3(0.0, 0.0, 0.0);
	//particle
	if(index <= ParticleNum/2 ){
		float cos_radz = cos(random.z * PI_2);
		float     rady =     random.y * PI2  ;
		add.x =  cos(rady) * cos_radz;
		add.y =  sin(rady) * cos_radz;
		add.z = -inv_pow(/*abs*/(cos_radz), 16.0);
		alpha = 1.0;
	}else {
		w *= 0.5;
		add.z = -particleSystemLength*random.w;
		alpha = random.x;
	}
	vec4 pos = vec4(0.0, 0.0, 0.0, 0.0);
	random = getRandom(index);
	pos.xyz += add*inv_pow(time,8.0)*4.0*random.z;

	pos.w    = gl_Vertex.w;

	gl_Position  = gl_ModelViewProjectionMatrix * pos;

	gl_PointSize = gl_Point.size / gl_Position.w * w;

	//alpha
	alpha *= (1.0-time);
	alpha = clamp(mix(0.0, alpha, time*10.0), 0.0, 1.0);
}

void main(void) {
	AllFunc();
}
