#version 120

// pa.frag
// @see http://www.nicovideo.jp/watch/sm22117119

#define PI 3.1415

uniform sampler2D texture;
uniform float     time;

void main (void)
{
	vec3 prim  = vec3(1.0, 1.0, 1.0);
	vec4 color = vec4(0.0);
	vec2 step[4] = vec2[4](
		vec2( 0.2, -1.0),
		vec2(-0.2, -1.5),
		vec2( 0.1, -2.0),
		vec2(-0.3, -3.0)
	);
	float speed =  0.1;
//	float shift = -1.0;
	float shift =  0.0;

	for(int i=0;i<step.length();i++){
		color += texture2D(texture,
						   gl_TexCoord[0].st + step[i]*(1.0+time)*speed)
					* (i+1);
	}

	color.rgb /= 3.0;
	color.a    = 1.0;

	float alpha = gl_FrontMaterial.diffuse.a*2.0;
	alpha += gl_TexCoord[0].t;

	color.a    = clamp(sin(PI*(shift + alpha)), 0.0, 1.0); 
	color.a   *= pow(gl_FrontMaterial.diffuse.a, 8.0)*cos(gl_TexCoord[0].s);

	color.r    = pow(color.r*2.0, 5.0*gl_FrontMaterial.diffuse.a);
	color.g    = pow(color.g*2.0, 5.0*gl_FrontMaterial.diffuse.a);
	color.b    = pow(color.b*2.0, 5.0*gl_FrontMaterial.diffuse.a);

	color.rgb *= prim;

	gl_FragColor = color;
}
